/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _ADMPROTO_H_RPCGEN
#define _ADMPROTO_H_RPCGEN

#include <rpc/rpc.h>


enum cfsstat {
	CFS_OK = 0,
	CFSERR_PERM = 1,
	CFSERR_IFULL = 2,
	CFSERR_NOINS = 3,
	CFSERR_EXIST = 4,
	CFSERR_NODIR = 5,
	CFSERR_BADKEY = 6,
	CFSERR_BADNAME = 7,
	CFSERR_SC_CANNOT_OPEN = 8,
};
typedef enum cfsstat cfsstat;

enum ciphers {
	CFS_STD_DES = 0,
	CFS_THREE_DES = 1,
	CFS_IDEA = 2,
	CFS_BLOWFISH = 3,
	CFS_SKIPJACK = 4,
	CFS_MACGUFFIN = 5,
	CFS_SAFER_SK128 = 6,
	CFS_TRUE_THREE_DES = 7,
	CFS_SMARTCARD = 40,
};
typedef enum ciphers ciphers;
#define CFS_MAXCOMP 255
#define CFS_MAXNAME 1024

struct cfs_adm_deskey {
	long pl;
	u_char primary[8];
	u_char secondary[8];
};
typedef struct cfs_adm_deskey cfs_adm_deskey;

struct cfs_adm_3deskey {
	long pl;
	u_char primary1[8];
	u_char primary2[8];
	u_char secondary1[8];
	u_char secondary2[8];
};
typedef struct cfs_adm_3deskey cfs_adm_3deskey;

struct cfs_adm_t3deskey {
	long pl;
	u_char primary1[8];
	u_char primary2[8];
	u_char primary3[8];
	u_char secondary1[8];
	u_char secondary2[8];
	u_char secondary3[8];
};
typedef struct cfs_adm_t3deskey cfs_adm_t3deskey;

struct cfs_adm_blowkey {
	long pl;
	u_char primary[16];
	u_char secondary[16];
};
typedef struct cfs_adm_blowkey cfs_adm_blowkey;

struct cfs_adm_mcgkey {
	long pl;
	u_char primary[16];
	u_char secondary[16];
};
typedef struct cfs_adm_mcgkey cfs_adm_mcgkey;

struct cfs_adm_saferkey {
	long pl;
	u_char primary[16];
	u_char secondary[16];
};
typedef struct cfs_adm_saferkey cfs_adm_saferkey;

struct cfs_adm_pin {
	u_char pin[256];
};
typedef struct cfs_adm_pin cfs_adm_pin;

struct cfs_admkey {
	ciphers cipher;
	union {
		cfs_adm_deskey deskey;
		cfs_adm_3deskey des3key;
		cfs_adm_blowkey blowkey;
		cfs_adm_mcgkey mcgkey;
		cfs_adm_saferkey saferkey;
		cfs_adm_t3deskey tdes3key;
		cfs_adm_pin pin;
	} cfs_admkey_u;
};
typedef struct cfs_admkey cfs_admkey;

struct cfs_attachargs {
	char *dirname;
	char *name;
	cfs_admkey key;
	int uid;
	int highsec;
	bool_t anon;
	int expire;
	int idle;
	int smsize;
	int scport;
};
typedef struct cfs_attachargs cfs_attachargs;

struct cfs_detachargs {
	char *name;
	int uid;
};
typedef struct cfs_detachargs cfs_detachargs;

#define ADM_PROGRAM 0x41234567
#define ADM_VERSION 2
#define ADMPROC_NULL 0
extern  void * admproc_null_2();
#define ADMPROC_ATTACH 1
extern  cfsstat * admproc_attach_2();
#define ADMPROC_DETACH 2
extern  cfsstat * admproc_detach_2();
extern int adm_program_2_freeresult ();

/* the xdr functions */
extern bool_t xdr_cfsstat ();
extern bool_t xdr_ciphers ();
extern bool_t xdr_cfs_adm_deskey ();
extern bool_t xdr_cfs_adm_3deskey ();
extern bool_t xdr_cfs_adm_t3deskey ();
extern bool_t xdr_cfs_adm_blowkey ();
extern bool_t xdr_cfs_adm_mcgkey ();
extern bool_t xdr_cfs_adm_saferkey ();
extern bool_t xdr_cfs_adm_pin ();
extern bool_t xdr_cfs_admkey ();
extern bool_t xdr_cfs_attachargs ();
extern bool_t xdr_cfs_detachargs ();

#endif /* !_ADMPROTO_H_RPCGEN */
